git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: Bert Wesarg <bert.wesarg@googlemail.com>
To: Uwe Kleine-Koenig <u.kleine-koenig@pengutronix.de>
To: Uwe Kleine-Koenig <u.kleine-koenig@pengutronix.de>
Cc: git@vger.kernel.org, Peter Simons <simons@cryp.to>,
	pasky@suse.cz, Per Cederqvist <ceder@lysator.liu.se>,
	Olaf Dabrunz <odabrunz@gmx.net>,
	Thomas Moschny <thomas.moschny@gmx.de>,
	martin f krafft <madduck@madduck.net>,
	Bert Wesarg <bert.wesarg@googlemail.com>
Subject: [TopGit PATCH 1/6] Let tg-update take a branch parameter
Date: Sun,  3 Oct 2010 23:25:52 +0200	[thread overview]
Message-ID: <1286141157-30422-1-git-send-email-bert.wesarg@googlemail.com> (raw)
In-Reply-To: <AANLkTim3gnU+_krD2QM0BAMf9DZi2_4hva6dq4WXcatH@mail.gmail.com>

Signed-off-by: Bert Wesarg <bert.wesarg@googlemail.com>

---
 README                     |    6 ++++--
 contrib/tg-completion.bash |    7 ++++++-
 tg-update.sh               |   18 ++++++++++++------
 3 files changed, 22 insertions(+), 9 deletions(-)

diff --git a/README b/README
index c418ff4..dba2345 100644 README
--- a/README
+++ b/README
@@ -472,13 +472,15 @@ tg import
 
 tg update
 ~~~~~~~~~
-	Update the current topic branch wrt. changes in the branches
-	it depends on and remote branches.
+	Update the current or specified topic branch wrt. changes in the
+	branches it depends on and remote branches.
 	This is performed in two phases - first,
 	changes within the dependencies are merged to the base,
 	then the base is merged into the topic branch.
 	The output will guide you in case of conflicts.
 
+	After the update the current branch is the specified one.
+
 	In case your dependencies are not up-to-date, tg update
 	will first recurse into them and update these.
 
diff --git a/contrib/tg-completion.bash b/contrib/tg-completion.bash
index 0ee233c..5aabc92 100755 contrib/tg-completion.bash
--- a/contrib/tg-completion.bash
+++ b/contrib/tg-completion.bash
@@ -423,7 +423,12 @@ _tg_summary ()
 
 _tg_update ()
 {
-	COMPREPLY=()
+	local cur="${COMP_WORDS[COMP_CWORD]}"
+
+	case "$cur" in
+	*)
+		__tgcomp "$(__tg_topics)"
+	esac
 }
 
 ### }}}
diff --git a/tg-update.sh b/tg-update.sh
index 73280c6..b256c7c 100644 tg-update.sh
--- a/tg-update.sh
+++ b/tg-update.sh
@@ -8,13 +8,19 @@ name=
 
 ## Parse options
 
-if [ -n "$1" ]; then
-	echo "Usage: tg [...] update" >&2
-	exit 1
-fi
-
-
-name="$(git symbolic-ref HEAD | sed 's#^refs/\(heads\|top-bases\)/##')"
+while [ -n "$1" ]; do
+	arg="$1"; shift
+	case "$arg" in
+	-*)
+		echo "Usage: tg [...] update [NAME]" >&2
+		exit 1;;
+	*)
+		[ -z "$name" ] || die "name already specified ($name)"
+		name="$arg";;
+	esac
+done
+
+[ -n "$name" ] || name="$(git symbolic-ref HEAD | sed 's#^refs/\(heads\|top-bases\)/##')"
 base_rev="$(git rev-parse --short --verify "refs/top-bases/$name" 2>/dev/null)" ||
 	die "not a TopGit-controlled branch"
 
-- 
tg: (29ab4cf..) bw/update-does-checkout (depends on: master)

  reply	other threads:[~2010-10-03 21:26 UTC|newest]

Thread overview: 39+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2010-10-03 19:15 planning a new topgit release Uwe Kleine-König
2010-10-03 21:21 ` Bert Wesarg
2010-10-03 21:25   ` Bert Wesarg [this message]
2010-10-03 21:25     ` [TopGit PATCH 2/6] tg-remote: use default remote if non is given Bert Wesarg
2010-10-03 21:25       ` [TopGit PATCH 3/6] tg-files: list files changed by the topic branch Bert Wesarg
2010-10-03 21:25         ` [TopGit PATCH 4/6] tg-prev/tg-next: commands to explore dependencies Bert Wesarg
2010-10-03 21:25           ` [TopGit PATCH 5/6] put die() messages to stderr Bert Wesarg
2010-10-03 21:25             ` [TopGit PATCH 6/6] tg-log: short cut to git log Bert Wesarg
     [not found]               ` <AANLkTi=Kwx5avY7xRdWLS931zK2fi7cj5Q8u3++bqRO+@mail.gmail.com>
2010-10-04  6:45                 ` Bert Wesarg
2010-10-04 19:06                   ` [TopGit PATCH] tg-log: move note from tg base to tg log Bert Wesarg
2010-10-04 21:05                     ` Štěpán Němec
2010-10-04 21:08                       ` Bert Wesarg
2010-10-04  6:45                 ` [TopGit PATCH 6/6] tg-log: short cut to git log Uwe Kleine-König
2010-10-03 21:55           ` [TopGit PATCH 4/6] tg-prev/tg-next: commands to explore dependencies Uwe Kleine-König
2010-10-04  6:48             ` Bert Wesarg
2010-10-03 22:03         ` [TopGit PATCH 3/6] tg-files: list files changed by the topic branch Uwe Kleine-König
2010-10-04  6:43           ` Bert Wesarg
2010-10-04  6:47             ` Uwe Kleine-König
2010-10-04  6:50               ` Bert Wesarg
2010-10-04  6:59                 ` Uwe Kleine-König
2010-10-04 13:16                   ` [TopGit PATCH] " Bert Wesarg
2010-10-04 13:52                     ` Uwe Kleine-König
2010-10-04 16:02                       ` Bert Wesarg
2010-10-04 18:27                         ` [TopGit PATCH v3] " Bert Wesarg
2010-10-04 20:09                           ` [TopGit PATCH] tg-patch: use pretty_tree Bert Wesarg
2010-10-04 23:02                             ` Bert Wesarg
2010-10-05  7:18                               ` Uwe Kleine-König
2010-10-05  8:05                                 ` Bert Wesarg
2010-10-05 19:04                                   ` [TopGit PATCH v2] " Bert Wesarg
2010-10-05 20:01                                     ` Uwe Kleine-König
2010-10-05 20:14                                       ` Bert Wesarg
2010-10-05  7:17                           ` [TopGit PATCH v3] tg-files: list files changed by the topic branch Uwe Kleine-König
2010-10-05 19:03                             ` [TopGit PATCH v4] " Bert Wesarg
2010-10-05 22:02                               ` Štěpán Němec
2010-10-06  6:11                                 ` Bert Wesarg
2010-10-03 22:00       ` [TopGit PATCH 2/6] tg-remote: use default remote if non is given Uwe Kleine-König
2010-10-04  3:13       ` Ævar Arnfjörð Bjarmason
2010-10-04  6:43         ` Uwe Kleine-König
2010-10-03 22:11   ` planning a new topgit release Uwe Kleine-König

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1286141157-30422-1-git-send-email-bert.wesarg@googlemail.com \
    --to=bert.wesarg@googlemail.com \
    --cc=ceder@lysator.liu.se \
    --cc=git@vger.kernel.org \
    --cc=madduck@madduck.net \
    --cc=odabrunz@gmx.net \
    --cc=pasky@suse.cz \
    --cc=simons@cryp.to \
    --cc=thomas.moschny@gmx.de \
    --cc=u.kleine-koenig@pengutronix.de \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).